=== modified file 'NEWS'
--- NEWS	2008-09-24 04:52:40 +0000
+++ NEWS	2008-09-10 23:12:59 +0000
@@ -7,16 +7,14 @@
       script. (Martin Albisetti)
 
     - Fixed broken template for project browsing with start-loggerhead
-      (Martin Albisetti)
-
-    - Added --reload options to restart the application when a python
-      file change. (Guillermo Gonzalez)
-
-    - Added error handling middleware. (Guillermo Gonzalez)
-
-    - Fix bug #243415 ("Tracebacks go to console but not log
-      file"). Also minor improvements to logging in serve-branches and
-      start-loggerhead. (Guillermo Gonzalez)
+      (Martin Albisett)
+      
+    - Added --reload options to restart the application when a python 
+      file change. (Guillermo Gonzalez) 
+
+    - Added error hanlding middleware. (Guillermo Gonzalez)
+    
+    - Fix Bug# 243415. Also minor improvements to logging in serve-branches and start-loggerhead. (Guillermo Gonzalez)
 
 1.6 [15Aug2008]
 ----------------

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2008-09-24 04:54:18 +0000
+++ loggerhead/apps/branch.py	2008-09-10 00:13:18 +0000
@@ -95,6 +95,7 @@
     def app(self, environ, start_response):
         self._url_base = environ['SCRIPT_NAME']
         self._static_url_base = environ.get('loggerhead.static.url')
+        environ['FRIENDLY_NAME'] = self.friendly_name
         if self._static_url_base is None:
             self._static_url_base = self._url_base
         self._environ = environ

=== modified file 'loggerhead/apps/error.py'
--- loggerhead/apps/error.py	2008-09-29 21:35:53 +0000
+++ loggerhead/apps/error.py	2008-09-09 03:47:24 +0000
@@ -15,39 +15,50 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import sys
+import logging
+from loggerhead.controllers import TemplatedBranchView
 from loggerhead.controllers.error_ui import ErrorUI
-
+  
 class ErrorHandlerApp(object):
-    """Class for WSGI error logging middleware."""
-
-    msg = " %s.%s: %s \n"
+    '''Class for WSGI error logging middleware.'''
+    
+    msg = " %s.%s: %s \n" 
 
     def __init__(self, application, **kwargs):
         self.application = application
-
+        self.log = getattr(application, 'log', None)
+                
     def __call__(self, environ, start_response):
         try:
             return self.application(environ, start_response)
         except:
-            # test if exc_info has been set, in the case that
-            # the error is caused before BranchWSGGIApp middleware
+            # test if exc_info has been set, in the case that 
+            # the error is caused before BranchWSGGIApp middleware 
             if environ.has_key('exc_info') and environ.has_key('branch'):
                 # Log and/or report any application errors
                 return self.handle_error(environ, start_response)
             else:
-                # simply propagate the error, this is logged
+                # simply propagate the error, this is logged 
                 # by paste.httpexceptions.TransLogger middleware
                 raise
 
     def handle_error(self, environ, start_response):
-        """Exception hanlder."""
+        '''Exception hanlder.'''
         self.log_error(environ)
         return errapp(environ, start_response)
-
+        
     def log_error(self, environ):
         exc_type, exc_object, exc_tb = environ['exc_info']
-        logger = environ['branch'].log
-        logger.exception(self.msg, exc_type.__module__,
+        logger = self.log
+        if environ.has_key('branch'):
+            logger = environ['branch'].log   
+        elif environ.has_key('FRIENDLY_NAME'):
+            logger = logging.getLogger('loggerhead.%s' % 
+                environ['FRIENDLY_NAME'])
+        elif logger is None:
+            logger = logging.getLogger('loggerhead')
+        logger.exception(self.msg, exc_type.__module__, 
                               exc_type.__name__, exc_object)
 
 

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2008-09-12 04:34:38 +0000
+++ loggerhead/changecache.py	2008-07-31 05:41:42 +0000
@@ -33,10 +33,18 @@
 
 with_lock = util.with_lock('_lock', 'ChangeCache')
 
-try:
+SQLITE_INTERFACE = os.environ.get('SQLITE_INTERFACE', 'sqlite3')
+
+if SQLITE_INTERFACE == 'sqlite3':
     from sqlite3 import dbapi2
-except ImportError:
-    from pysqlite2 import dbapi2
+    _param_marker = '?'
+
+_select_stmt = ("select data from revisiondata where revid = ?"
+                ).replace('?', _param_marker)
+_insert_stmt = ("insert into revisiondata (revid, data) "
+                "values (?, ?)").replace('?', _param_marker)
+
+
 
 
 class FakeShelf(object):
@@ -57,8 +65,7 @@
     def _unserialize(self, data):
         return cPickle.loads(str(data))
     def get(self, revid):
-        self.cursor.execute(
-            "select data from revisiondata where revid = ?", (revid,))
+        self.cursor.execute(_select_stmt, (revid,))
         filechange = self.cursor.fetchone()
         if filechange is None:
             return None
@@ -66,9 +73,7 @@
             return self._unserialize(filechange[0])
     def add(self, revid_obj_pairs):
         for  (r, d) in revid_obj_pairs:
-            self.cursor.execute(
-                "insert into revisiondata (revid, data) values (?, ?)",
-                (r, self._serialize(d)))
+            self.cursor.execute(_insert_stmt, (r, self._serialize(d)))
         self.connection.commit()
 
 

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2008-09-30 02:04:14 +0000
+++ loggerhead/controllers/__init__.py	2008-07-22 00:40:03 +0000
@@ -73,7 +73,6 @@
             args.append(arg)
 
         vals = {
-            'static_url': self._branch.static_url,
             'branch': self._branch,
             'util': util,
             'history': h,

=== modified file 'loggerhead/controllers/diff_ui.py'
--- loggerhead/controllers/diff_ui.py	2008-09-29 21:35:13 +0000
+++ loggerhead/controllers/diff_ui.py	2008-08-14 02:49:52 +0000
@@ -19,27 +19,42 @@
 from cStringIO import StringIO
 import logging
 import time
+import sys
 
+from paste import httpexceptions
 from paste.request import path_info_pop
 
+from loggerhead import history
+from loggerhead import util
+from loggerhead.templatefunctions import templatefunctions
+
+import bzrlib
+from bzrlib import branch
 from bzrlib.diff import show_diff_trees
 
 
 log = logging.getLogger("loggerhead.controllers")
 
 class DiffUI(object):
-    """Class to output a diff for a single file or revisions."""
+    """
 
+    Class to output a diff for a single file or revisions.
+    """
+    
     def __init__(self, branch, history):
         self._branch = branch
         self._history = history
         self.log = history.log
 
+    
     def __call__(self, environ, start_response):
         # /diff/<rev_id>/<rev_id>
-        """Default method called from /diff URL."""
+        """
+        Default method called from /diff URL.
+        """
+
         z = time.time()
-
+        
         args = []
         while 1:
             arg = path_info_pop(environ)
@@ -55,20 +70,20 @@
         if len(args) is 2:
             revid_to = self._history.fix_revid(args[1])
         else:
-            revid_to = change.parents[0].revid
+            revid_to = change.parents[0].revid 
 
 
         repo = self._branch.branch.repository
         revtree1 = repo.revision_tree(revid_from)
         revtree2 = repo.revision_tree(revid_to)
-
+        
         diff_content_stream = StringIO()
-        show_diff_trees(revtree1, revtree2, diff_content_stream,
+        show_diff_trees(revtree1, revtree2, diff_content_stream, 
                         old_label='', new_label='')
 
         content = diff_content_stream.getvalue()
 
-        self.log.info('/diff %r:%r in %r secs' % (revid_from, revid_to,
+        self.log.info('/diff %r:%r in %r secs' % (revid_from, revid_to, 
                                                   time.time() - z))
 
         revno1 = self._history.get_revno(revid_from)

=== modified file 'loggerhead/controllers/directory_ui.py'
--- loggerhead/controllers/directory_ui.py	2008-09-30 02:57:08 +0000
+++ loggerhead/controllers/directory_ui.py	2008-08-16 21:53:52 +0000
@@ -47,9 +47,6 @@
     def __init__(self, static_url_base, path, name):
         class _branch(object):
             context_url = 1
-            @staticmethod
-            def static_url(path):
-                return self._static_url_base + path
         self._branch = _branch
         self._history = None
         self._path = path
@@ -64,6 +61,8 @@
         listing.sort(key=lambda x: x.lower())
         dirs = []
         parity = 0
+        def static_url(path):
+            return self._static_url_base + path
         for d in listing:
             p = os.path.join(self._path, d)
             try:
@@ -80,5 +79,6 @@
         return {
             'dirs': dirs,
             'name': self._name,
+            'static_url': static_url,
             'directory_breadcrumbs': directory_breadcrumbs,
             }

=== modified file 'loggerhead/controllers/error_ui.py'
--- loggerhead/controllers/error_ui.py	2008-09-29 21:32:30 +0000
+++ loggerhead/controllers/error_ui.py	2008-09-09 03:47:24 +0000
@@ -16,11 +16,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-from StringIO import StringIO
-import traceback
-
 from loggerhead.controllers import TemplatedBranchView
-from loggerhead import util
 
 class ErrorUI(TemplatedBranchView):
 
@@ -29,19 +25,11 @@
     def __init__(self, branch, exc_info):
         super(ErrorUI, self).__init__(branch, None)
         self.exc_info = exc_info
-
+    
     def get_values(self, h, args, kw, headers):
         exc_type, exc_object, exc_tb = self.exc_info
-        description = StringIO()
-        traceback.print_exception(exc_type, exc_object, None, file=description)
-        directory_breadcrumbs = (
-            util.directory_breadcrumbs(
-                self._branch.friendly_name,
-                self._branch.is_root,
-                'changes'))
         return {
-            'branch': self._branch,
-            'error_title': 'An unexpected error occurred while proccesing the request:',
-            'error_description': description.getvalue(),
-            'directory_breadcrumbs': directory_breadcrumbs,
-        }
+            'error_title':'Error',
+            'error_description':exc_object,
+            'error_properties':[self.exc_info],
+        }
\ No newline at end of file

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2008-10-01 22:23:24 +0000
+++ loggerhead/controllers/inventory_ui.py	2008-08-16 21:53:52 +0000
@@ -22,8 +22,6 @@
 
 from paste.httpexceptions import HTTPServerError
 
-from bzrlib.revision import is_null as is_null_rev
-
 from loggerhead import util
 from loggerhead.controllers import TemplatedBranchView
 
@@ -47,58 +45,45 @@
         else:
             revid = h.last_revid
 
+        try:
+            inv = h.get_inventory(revid)
+        except:
+            self.log.exception('Exception fetching changes')
+            raise HTTPServerError('Could not fetch changes')
+
+        file_id = kw.get('file_id', inv.root.file_id)
+        start_revid = kw.get('start_revid', None)
+        sort_type = kw.get('sort', None)
+
         # no navbar for revisions
         navigation = util.Container()
+
+        change = h.get_changes([ revid ])[0]
+        # add parent & merge-point branch-nick info, in case it's useful
+        h.get_branch_nicks([ change ])
+
+        path = inv.id2path(file_id)
+        if not path.startswith('/'):
+            path = '/' + path
+        idpath = inv.get_idpath(file_id)
+        if len(idpath) > 1:
+            updir = dirname(path)
+            updir_file_id = idpath[-2]
+        else:
+            updir = None
+            updir_file_id = None
+        if updir == '/':
+            updir_file_id = None
+
         # Directory Breadcrumbs
         directory_breadcrumbs = util.directory_breadcrumbs(
                 self._branch.friendly_name,
                 self._branch.is_root,
                 'files')
 
-        if not is_null_rev(revid):
-            try:
-                inv = h.get_inventory(revid)
-            except:
-                self.log.exception('Exception fetching changes')
-                raise HTTPServerError('Could not fetch changes')
-
-            file_id = kw.get('file_id', inv.root.file_id)
-            start_revid = kw.get('start_revid', None)
-            sort_type = kw.get('sort', None)
-
-            change = h.get_changes([ revid ])[0]
-            # add parent & merge-point branch-nick info, in case it's useful
-            h.get_branch_nicks([ change ])
-
-            path = inv.id2path(file_id)
-            if not path.startswith('/'):
-                path = '/' + path
-            idpath = inv.get_idpath(file_id)
-            if len(idpath) > 1:
-                updir = dirname(path)
-                updir_file_id = idpath[-2]
-            else:
-                updir = None
-                updir_file_id = None
-            if updir == '/':
-                updir_file_id = None
-
-            # Create breadcrumb trail for the path within the branch
-            branch_breadcrumbs = util.branch_breadcrumbs(path, inv, 'files')
-            filelist = h.get_filelist(inv, file_id, sort_type)
-        else:
-            inv = None
-            file_id = None
-            start_revid = None
-            sort_type = None
-            change = None
-            path = "/"
-            idpath = None
-            updir = None
-            updir_file_id = None
-            branch_breadcrumbs = []
-            filelist = []
-
+        # Create breadcrumb trail for the path within the branch
+        branch_breadcrumbs = util.branch_breadcrumbs(path, inv, 'files')
+        
         return {
             'branch': self._branch,
             'util': util,
@@ -108,7 +93,7 @@
             'path': path,
             'updir': updir,
             'updir_file_id': updir_file_id,
-            'filelist': filelist,
+            'filelist': h.get_filelist(inv, file_id, sort_type),
             'history': h,
             'posixpath': posixpath,
             'navigation': navigation,

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2008-09-27 05:13:24 +0000
+++ loggerhead/history.py	2008-09-09 22:47:45 +0000
@@ -341,11 +341,8 @@
             return revid
         if revid == 'head:':
             return self.last_revid
-        try:
-            if self.revno_re.match(revid):
-                revid = self._revno_revid[revid]
-        except KeyError:
-            raise bzrlib.errors.NoSuchRevision(self._branch.nick, revid)
+        if self.revno_re.match(revid):
+            revid = self._revno_revid[revid]
         return revid
 
     def get_file_view(self, revid, file_id):

=== modified file 'loggerhead/templates/breadcrumbs.pt'
--- loggerhead/templates/breadcrumbs.pt	2008-09-30 02:04:14 +0000
+++ loggerhead/templates/breadcrumbs.pt	2008-08-16 21:53:52 +0000
@@ -15,7 +15,7 @@
 
 <!-- Directory breadcrumbs (for the path leading up to the branch) -->
 <span metal:define-macro="directory" class="breadcrumb">
-    <tal:block repeat="crumb directory_breadcrumbs"><span tal:condition="not:repeat/crumb/start">/</span><a tal:attributes="href python:static_url('/'+crumb['path'])" tal:content="crumb/dir_name" /></tal:block>
+    <tal:block repeat="crumb directory_breadcrumbs"><span tal:condition="not:repeat/crumb/start">/</span><a tal:attributes="href string:/${crumb/path}${crumb/suffix}" tal:content="crumb/dir_name" /></tal:block>
 </span>
 
 </body>

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2008-10-01 22:20:26 +0000
+++ loggerhead/templates/changelog.pt	2008-09-09 22:47:45 +0000
@@ -23,14 +23,10 @@
            <tal:no-link condition="not: branch/branch_link">
              <span metal:use-macro="breadcrumbs/directory"></span>
            </tal:no-link>
-           <tal:block condition="changes">
-             : changes
-             <tal:block condition="filter_file_id">to <span tal:content="python:history.get_path(revid, filter_file_id)" /></tal:block>
-             <tal:block condition="start_revid">from revision
-               <span tal:content="python:history.get_revno(start_revid)"/>
-             </tal:block>
-             <tal:block condition="query">matching <tal:block content="query" /></tal:block>
-           </tal:block>
+           : changes
+          <tal:block condition="filter_file_id">to <span tal:content="python:history.get_path(revid, filter_file_id)" /></tal:block>
+          <tal:block condition="start_revid">from revision <tal:block content="python:history.get_revno(start_revid)" /></tal:block>
+          <tal:block condition="query">matching <tal:block content="query" /></tal:block>
          </h1>
         </tal:block>
 

=== modified file 'loggerhead/templates/error.pt'
--- loggerhead/templates/error.pt	2008-09-29 21:32:30 +0000
+++ loggerhead/templates/error.pt	2008-09-09 03:47:24 +0000
@@ -1,30 +1,13 @@
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
 <tal:block define="onload string:load()">
-  <html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros/main">
+  <html xmlns="http://www.w3.org/1999/xhtml">
     <head>
-      <title metal:fill-slot="title"
-             tal:content="string:${branch/friendly_name} : error"></title>
+      <title tal:content="error_title">
+      </title>
     </head>
     <body>
-        <tal:block metal:fill-slot="heading">
-        <h1>
-           <tal:has-link condition="branch/branch_link">
-            <a tal:attributes="href branch/branch_link"
-               tal:content="branch/friendly_name">
-               nice/branch/name
-            </a>
-           </tal:has-link>
-            <tal:no-link condition="not: branch/branch_link">
-                <span metal:use-macro="breadcrumbs/directory"></span>
-            </tal:no-link>
-           : error
-        </h1>
-        <pre>
-            <p tal:content="error_title"/>
-            <p tal:content="error_description"/>
-        </pre>
-        <br/><br/>
-        </tal:block>
+        <p tal:content="error_description"/>
+        <p tal:content="error_properties"/>
     </body>
   </html>
 </tal:block>

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2008-10-01 22:15:10 +0000
+++ loggerhead/templates/inventory.pt	2008-08-16 04:57:38 +0000
@@ -20,130 +20,123 @@
       <span tal:condition="not: branch/branch_link">
         <span metal:use-macro="breadcrumbs/directory" />
       </span>
-      <tal:block condition="python:change">
-        : viewing
-        <span metal:use-macro="breadcrumbs/branch" />
-        for revision <span tal:content="change/revno"/>
-      </tal:block>
+      : viewing
+      <span metal:use-macro="breadcrumbs/branch" />
+      for revision <span tal:content="change/revno"/>
     </h1>
 
     <div metal:fill-slot="content">
-        <p tal:condition="python:not change">
-          No revisions!
-        </p>
-        <p tal:condition="python:change">
-          <ul id="submenuTabs">
-              <li id="first">
-                  <a tal:attributes="href python:url(['/revision', change.revno], clear=1, start_revid=change.revno)">view revision</a>
-              </li>
-              <li id="last">
-                  <a tal:attributes="href python:url(['/changes', change.revno], clear=1, start_revid=change.revno)">view branch changes</a>
-              </li>
-          </ul>
-
-          <tal:revision-info replace="structure python:revisioninfo(url, branch, change)" />
-
-          <table id="logentries">
-            <tr class="logheader">
-              <th class="summarycell"><a tal:attributes="href python:url(['/files', revid], sort='filename')">Filename</a></th>
-              <th class="datecell">Latest Rev</th>
-              <th class="datecell"><a tal:attributes="href python:url(['/files', revid], sort='date')">Last Changed</a></th>
-              <th class="timedate"><a tal:attributes="href python:url(['/files', revid], sort='size')">Size</a></th>
-              <th class="expandcell"></th>
-              <th class="expandcell"></th>
-            </tr>
-
-            <tr class="blueRow0" tal:condition="python:updir">
-                <td class="summcell" colspan="6">
-                    <a tal:attributes="href python:url(['/files', revid], file_id=updir_file_id)" class="link">
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_folder_up.gif')" />..</a>
-                </td>
-            </tr>
-
-            <!-- Show this if it's a directory -->
-            <tal:block repeat="file filelist">
-            <tr tal:attributes="class string:blueRow${file/parity}" tal:condition="python:file.kind=='directory'">
-                <td class="autcell"><a tal:attributes="href python:url(['/files', change.revno], file_id=file.file_id)">
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_folder.gif');
-                                             title string:Go to ${file/filename}" />
-                    </a>
-
-                 <a tal:attributes="href python:url(['/files', change.revno], file_id=file.file_id)" 
-                                        tal:content="file/filename" class="link"></a>
-                 </td>
-                 <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
-                                                     title string:Show revision ${file/change/revno}"
-                                     tal:content="file/change/revno"></a>
-                 </td>
-                 <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
-                 <td class="timedate2"></td>
-                 <td class="expcell"><a tal:attributes="href python:url(['/changes'], start_revid=start_revid, filter_file_id=file.file_id);
-                                                     title string:Show revision ${file/change/revno}">
-                                      <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif')" alt="Diff" />
-                                     </a>
-              </td>
-                <td class="expcell"></td>
-            </tr>
-
-            <!-- Show this if it's a symlink -->
-            <tr tal:attributes="class string:blueRow${file/parity}" tal:condition="python:file.kind=='symlink'">
-                <td class="autcell"><a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)">
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_flecha.gif')" alt="Symlink" />
-                    </a>
-
-                 <a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)" 
-                                        tal:content="file/filename" class="link"></a>
-                 </td>
-                 <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
-                                                     title string:Show revision ${file/change/revno}"
-                                     tal:content="file/change/revno"></a>
-                 </td>
-                 <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
-                 <td class="timedate2">.</td>
-                 <td class="expcell"><a tal:attributes="href python:url(['/changes'], start_revid=start_revid, filter_file_id=file.file_id);
-                                                        title string:Show revision ${file/change/revno}">
-                                          <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif');
-                                                               title string:Show revision ${file/change/revno}" />
-                                     </a>
-              </td>
-                <td class="expcell"></td>
-            </tr>
-
-            <!-- Show this if it's a regular file -->
-            <tr tal:attributes="class string:blueRow${file/parity}" tal:condition="python:file.kind=='file'">
-                <td class="autcell"><a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)">
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_file.gif');
-                                             title string:Annotate ${file/filename}"
-                             tal:condition="python:file.executable is False" />
-                        <!-- Show a different icon id the file executable -->
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_file_modify.gif'); 
-                                             title string:Annotate ${file/filename}"
-                             tal:condition="python:file.executable is True" alt="File" />
-                    </a>
-
-              <a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)"
-                                     tal:content="file/filename" class="link"></a></td>
-              <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
-                                                  title string:Show revision ${file/change/revno}"
-                                  tal:content="file/change/revno"></a>
-              </td>
-              <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
-              <td class="timedate2" tal:content="python:util.human_size(file.size)"></td>
-              <td class="expcell"><a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id);
-                                                     title string:Annotate ${file/filename}">
-                                      <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif')" alt="Diff" />
-                                     </a>
-              </td>
-              <td class="expcell">
-                 <a tal:attributes="href python:url(['/download', file.revid, file.file_id, file.filename]);
-                                    title string:Download ${file/filename} at revision ${file/change/revno}">
-                   <img tal:attributes="src python:branch.static_url('/static/images/ico_file_download.gif')" alt="Download File" />
-                 </a>
-              </td>
-           </tr>
-          </tal:block>
-        </table>
-      </p>
+        <ul id="submenuTabs">
+            <li id="first">
+                <a tal:attributes="href python:url(['/revision', change.revno], clear=1, start_revid=change.revno)">view revision</a>
+            </li>
+            <li id="last">
+                <a tal:attributes="href python:url(['/changes', change.revno], clear=1, start_revid=change.revno)">view branch changes</a>
+            </li>
+        </ul>
+
+      <tal:revision-info replace="structure python:revisioninfo(url, branch, change)" />
+
+      <table id="logentries">
+          <tr class="logheader">
+            <th class="summarycell"><a tal:attributes="href python:url(['/files', revid], sort='filename')">Filename</a></th>
+            <th class="datecell">Latest Rev</th>
+            <th class="datecell"><a tal:attributes="href python:url(['/files', revid], sort='date')">Last Changed</a></th>
+            <th class="timedate"><a tal:attributes="href python:url(['/files', revid], sort='size')">Size</a></th>
+            <th class="expandcell"></th>
+            <th class="expandcell"></th>
+          </tr>
+
+          <tr class="blueRow0" tal:condition="python:updir">
+              <td class="summcell" colspan="6">
+                  <a tal:attributes="href python:url(['/files', revid], file_id=updir_file_id)" class="link">
+                      <img tal:attributes="src python:branch.static_url('/static/images/ico_folder_up.gif')" />..</a>
+              </td>
+          </tr>
+          
+          <!-- Show this if it's a directory --> 
+          <tal:block repeat="file filelist">
+          <tr tal:attributes="class string:blueRow${file/parity}" tal:condition="python:file.kind=='directory'">
+              <td class="autcell"><a tal:attributes="href python:url(['/files', change.revno], file_id=file.file_id)">
+                      <img tal:attributes="src python:branch.static_url('/static/images/ico_folder.gif');
+                                           title string:Go to ${file/filename}" />
+                  </a>
+
+               <a tal:attributes="href python:url(['/files', change.revno], file_id=file.file_id)" 
+                                      tal:content="file/filename" class="link"></a>
+               </td>
+               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
+                                                   title string:Show revision ${file/change/revno}"
+                                   tal:content="file/change/revno"></a>
+               </td>
+               <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
+               <td class="timedate2"></td>
+               <td class="expcell"><a tal:attributes="href python:url(['/changes'], start_revid=start_revid, filter_file_id=file.file_id);
+                                                   title string:Show revision ${file/change/revno}">
+                                    <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif')" alt="Diff" />
+                                   </a>
+            </td>
+              <td class="expcell"></td>
+          </tr>
+          
+          <!-- Show this if it's a symlink --> 
+          <tr tal:attributes="class string:blueRow${file/parity}" tal:condition="python:file.kind=='symlink'">
+              <td class="autcell"><a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)">
+                      <img tal:attributes="src python:branch.static_url('/static/images/ico_flecha.gif')" alt="Symlink" />
+                  </a>
+
+               <a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)" 
+                                      tal:content="file/filename" class="link"></a>
+               </td>
+               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
+                                                   title string:Show revision ${file/change/revno}"
+                                   tal:content="file/change/revno"></a>
+               </td>
+               <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
+               <td class="timedate2">.</td>
+               <td class="expcell"><a tal:attributes="href python:url(['/changes'], start_revid=start_revid, filter_file_id=file.file_id);
+                                                      title string:Show revision ${file/change/revno}">
+                                        <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif');
+                                                             title string:Show revision ${file/change/revno}" />
+                                   </a>
+            </td>
+              <td class="expcell"></td>
+          </tr>
+
+          <!-- Show this if it's a regular file --> 
+          <tr tal:attributes="class string:blueRow${file/parity}" tal:condition="python:file.kind=='file'">
+              <td class="autcell"><a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)">
+                      <img tal:attributes="src python:branch.static_url('/static/images/ico_file.gif');
+                                           title string:Annotate ${file/filename}"
+                           tal:condition="python:file.executable is False" />
+                      <!-- Show a different icon id the file executable -->
+                      <img tal:attributes="src python:branch.static_url('/static/images/ico_file_modify.gif'); 
+                                           title string:Annotate ${file/filename}"
+                           tal:condition="python:file.executable is True" alt="File" />
+                  </a>
+
+            <a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)"
+                                   tal:content="file/filename" class="link"></a></td>
+            <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
+                                                title string:Show revision ${file/change/revno}"
+                                tal:content="file/change/revno"></a>
+            </td>
+            <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
+            <td class="timedate2" tal:content="python:util.human_size(file.size)"></td>
+            <td class="expcell"><a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id);
+                                                   title string:Annotate ${file/filename}">
+                                    <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif')" alt="Diff" />
+                                   </a>
+            </td>
+            <td class="expcell">
+               <a tal:attributes="href python:url(['/download', file.revid, file.file_id, file.filename]);
+                                  title string:Download ${file/filename} at revision ${file/change/revno}">
+                 <img tal:attributes="src python:branch.static_url('/static/images/ico_file_download.gif')" alt="Download File" />
+               </a>
+            </td>
+         </tr>
+        </tal:block>
+      </table>
     </div>
   </body>
 </html>

=== modified file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2008-09-12 04:36:13 +0000
+++ loggerhead/tests/test_simple.py	2008-09-09 22:42:27 +0000
@@ -50,7 +50,7 @@
     """
 
     def setUpLoggerhead(self):
-        app = TestApp(BranchWSGIApp(self.branch, '').app)
+        app = TestApp(BranchWSGIApp(self.branch).app)
         return app
 
     def tearDown(self):

=== modified file 'serve-branches'
--- serve-branches	2008-09-24 04:52:40 +0000
+++ serve-branches	2008-09-10 23:12:59 +0000
@@ -52,8 +52,8 @@
     parser.add_option("--reload", action="store_true", dest="reload",
                       help="Restarts the application when changing python"
                            " files. Only used for development purposes.")
-    parser.add_option('--log-folder', dest="log_folder",
-                      type=str, help="The directory to place log files in.")
+    parser.add_option('--log-folder', dest="log_folder", 
+                      type=str, help="The directory to place log files")
     parser.add_option("--version", action="store_true", dest="show_version",
                       help="Print the software version and exit")
     return parser
@@ -82,7 +82,7 @@
     if options.trunk_dir and not options.user_dirs:
         print "--trunk-dir is only valid with --user-dirs"
         sys.exit(1)
-
+        
     if options.reload:
         if Reloader.is_installed():
             Reloader.install()
@@ -96,7 +96,7 @@
         app = UserBranchesFromFileSystemRoot(path, options.trunk_dir)
     else:
         app = BranchesFromFileSystemRoot(path)
-
+    
     # setup_logging()
     logging.basicConfig()
     logging.getLogger('').setLevel(logging.DEBUG)
@@ -127,7 +127,7 @@
         pass
     else:
         app = PrefixMiddleware(app, prefix=prefix)
-
+    
     if not options.user_port:
         port = '8080'
     else:

